bc: fix interactive handling of comments in strings and quotes in comments
[oweals/busybox.git] / testsuite / testing.sh
old mode 100755 (executable)
new mode 100644 (file)
index e253e1a..f5b7569
@@ -1,31 +1,32 @@
-# Simple test harness infrastructurei for BusyBox
+# Simple test harness infrastructure for BusyBox
 #
 # Copyright 2005 by Rob Landley
 #
 # License is GPLv2, see LICENSE in the busybox tarball for full license text.
 
-# This file defines two functions, "testing" and "optionflag"
+# This file defines two functions, "testing" and "optional"
+# and a couple more...
 
 # The following environment variables may be set to enable optional behavior
 # in "testing":
 #    VERBOSE - Print the diff -u of each failed test case.
 #    DEBUG - Enable command tracing.
-#    SKIP - do not perform this test (this is set by "optionflag")
+#    SKIP - do not perform this test (this is set by "optional")
 #
 # The "testing" function takes five arguments:
-#      $1) Description to display when running command
-#      $2) Command line arguments to command
-#      $3) Expected result (on stdout)
-#      $4) Data written to file "input"
-#      $5) Data written to stdin
+#      $1) Test description
+#      $2) Command(s) to run. May have pipes, redirects, etc
+#      $3) Expected result on stdout
+#      $4) Data to be written to file "input"
+#      $5) Data to be written to stdin
 #
-# The exit value of testing is the exit value of the command it ran.
+# The exit value of testing is the exit value of $2 it ran.
 #
 # The environment variable "FAILCOUNT" contains a cumulative total of the
 # number of failed tests.
 
 # The "optional" function is used to skip certain tests, ala:
-#   optionflag CONFIG_FEATURE_THINGY
+#   optional FEATURE_THINGY
 #
 # The "optional" function checks the environment variable "OPTIONFLAGS",
 # which is either empty (in which case it always clears SKIP) or
 export FAILCOUNT=0
 export SKIP=
 
+# Helper for helpers. Oh my...
+
+test x"$ECHO" != x"" || {
+       ECHO="echo"
+       test x"`echo -ne`" = x"" || {
+               # Compile and use a replacement 'echo' which understands -e -n
+               ECHO="$PWD/echo-ne"
+               test -x "$ECHO" || {
+                       gcc -Os -o "$ECHO" ../scripts/echo.c || exit 1
+               }
+       }
+       export ECHO
+}
+
 # Helper functions
 
 optional()
 {
-  option=`echo "$OPTIONFLAGS" | egrep "(^|:)$1(:|\$)"`
-  # Not set?
-  if [ -z "$1" ] || [ -z "$OPTIONFLAGS" ] || [ ${#option} -ne 0 ]
-  then
-    SKIP=""
-    return
-  fi
-  SKIP=1
+       SKIP=
+       while test "$1"; do
+               case "${OPTIONFLAGS}" in
+                       *:$1:*) ;;
+                       *) SKIP=1; return ;;
+               esac
+               shift
+       done
 }
 
 # The testing function
 
-testing ()
+testing()
 {
   NAME="$1"
-  [ -z "$1" ] && NAME=$2
+  [ -n "$1" ] || NAME="$2"
 
   if [ $# -ne 5 ]
   then
-    echo "Test $NAME has the wrong number of arguments ($# $*)" >&2
-    exit
+    echo "Test $NAME has wrong number of arguments: $# (must be 5)" >&2
+    exit 1
   fi
 
-  [ -n "$DEBUG" ] && set -x
+  [ -z "$DEBUG" ] || set -x
 
   if [ -n "$SKIP" ]
   then
@@ -70,24 +85,25 @@ testing ()
     return 0
   fi
 
-  echo -ne "$3" > expected
-  echo -ne "$4" > input
-  [ -z "$VERBOSE" ] || echo "echo '$5' | $2"
-  echo -ne "$5" | eval "$2" > actual
+  $ECHO -ne "$3" > expected
+  $ECHO -ne "$4" > input
+  [ -z "$VERBOSE" ] || echo ======================
+  [ -z "$VERBOSE" ] || echo "echo -ne '$4' >input"
+  [ -z "$VERBOSE" ] || echo "echo -ne '$5' | $2"
+  $ECHO -ne "$5" | eval "$2" > actual
   RETVAL=$?
 
-  cmp expected actual > /dev/null
-  if [ $? -ne 0 ]
+  if cmp expected actual >/dev/null 2>/dev/null
   then
-    FAILCOUNT=$[$FAILCOUNT+1]
-    echo "FAIL: $NAME"
-    [ -n "$VERBOSE" ] && diff -u expected actual
-  else
     echo "PASS: $NAME"
+  else
+    FAILCOUNT=$(($FAILCOUNT + 1))
+    echo "FAIL: $NAME"
+    [ -z "$VERBOSE" ] || diff -u expected actual
   fi
   rm -f input expected actual
 
-  [ -n "$DEBUG" ] && set +x
+  [ -z "$DEBUG" ] || set +x
 
   return $RETVAL
 }
@@ -97,17 +113,18 @@ testing ()
 # the file is assumed to already be there and only its library dependencies
 # are copied.
 
-function mkchroot
+mkchroot()
 {
   [ $# -lt 2 ] && return
 
-  echo -n .
+  $ECHO -n .
 
   dest=$1
   shift
   for i in "$@"
   do
-    [ "${i:0:1}" == "/" ] || i=$(which $i)
+    #bashism: [ "${i:0:1}" == "/" ] || i=$(which $i)
+    i=$(which $i) # no-op for /bin/prog
     [ -f "$dest/$i" ] && continue
     if [ -e "$i" ]
     then
@@ -126,7 +143,7 @@ function mkchroot
 # Needed commands listed on command line
 # Script fed to stdin.
 
-function dochroot
+dochroot()
 {
   mkdir tmpdir4chroot
   mount -t ramfs tmpdir4chroot tmpdir4chroot
@@ -135,7 +152,7 @@ function dochroot
 
   # Copy utilities from command line arguments
 
-  echo -n "Setup chroot"
+  $ECHO -n "Setup chroot"
   mkchroot tmpdir4chroot $*
   echo
 
@@ -151,4 +168,3 @@ function dochroot
   umount -l tmpdir4chroot
   rmdir tmpdir4chroot
 }
-